package org.noritan.textconverter;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.Writer;
import org.noritan.util.Base64InputStream;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) noritan</p>
 * <p>Organization: NO</p>
 * @author noritan
 * @version 1.0
 */

public class Base64Converter implements TextConverter {
  private final String encoding;

  public Base64Converter(String encoding) {
    this.encoding = encoding;
  }

  public void convert(Reader baseReader, Writer baseWriter) throws IOException {
    WhiteSpaceSkipReader skipReader = new WhiteSpaceSkipReader(baseReader);
    Base64InputStream base64Stream = new Base64InputStream(skipReader);
    InputStreamReader inputStreamReader = new InputStreamReader(base64Stream, this.encoding);
    BufferedReader reader = new BufferedReader(inputStreamReader);
    BufferedWriter writer = new BufferedWriter(baseWriter);
    try {
      String lineBuffer;
      while ((lineBuffer = reader.readLine()) != null) {
        writer.write(lineBuffer);
        writer.write('\n');
      }
    }
    catch (IOException ex) {
      // Exception in reader.readLine()
      throw ex;
    }
    finally {
      // Flush writer.
      writer.flush();
    }
  }

  public String toString() {
    return "BASE64-" + encoding;
  }
}
