package org.noritan.textconverter;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) noritan</p>
 * <p>Organization: NO</p>
 * @author noritan
 * @version 1.0
 */

public class NullConverter implements TextConverter {

  public void convert(Reader baseReader, Writer baseWriter)
      throws IOException {
    BufferedReader reader = new BufferedReader(baseReader);
    BufferedWriter writer = new BufferedWriter(baseWriter);
    try {
      String lineBuffer;
      while ((lineBuffer = reader.readLine()) != null) {
        writer.write(convertALine(lineBuffer));
        writer.write('\n');
      }
    }
    catch (IOException ex) {
      // Exception in reader.readLine()
      throw ex;
    }
    finally {
      // Flush writer.
      writer.flush();
    }
  }

  protected String convertALine(String line) {
    return line;
  }

  public String toString() {
    return "NULL";
  }
}
