package org.noritan.textconverter;

import java.io.IOException;
import java.io.Reader;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) noritan</p>
 * <p>Organization: NO</p>
 * @author noritan
 * @version 1.0
 */

public class WhiteSpaceSkipReader extends Reader {
  private Reader reader;

  public WhiteSpaceSkipReader(Reader reader) {
    this.reader = reader;
  }

  /**
   * Read characters into a portion of an array.
   *
   * @param cbuf Destination buffer
   * @param off Offset at which to start storing characters
   * @param len Maximum number of characters to read
   * @return The number of characters read, or -1 if the end of the stream has
   *   been reached
   * @throws IOException If an I/O error occurs
   */
  public int read(char[] cbuf, int off, int len) throws IOException {
    int index = 0;
    while (index < len) {
      int ch = reader.read();
      if (ch < 0) {
        if (index == 0) return -1; // EOF detected.
        break;
      }
      if (!Character.isWhitespace((char) ch)) {
        cbuf[off + index++] = (char) ch;
      }
    }
    return index;
  }

  /**
   * Close the stream.
   *
   * @throws IOException If an I/O error occurs
   */
  public void close() throws IOException {
    reader.close();
  }
}
